﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Mapping;

namespace FeatureServiceDemo.Demo1
{
	internal class ChangeRenderer : Button
	{
		protected override void OnClick()
		{
			var groupLayer = MapView.Active.Map.FindLayers("Buildings_Hosted").First() as GroupLayer;
			var fl = groupLayer.GetLayersAsFlattenedList().OfType<FeatureLayer>()
																.First(lyr => lyr.Name == "Buildings_Hosted");
			QueuedTask.Run(() =>
			{
				groupLayer.SetExpanded(true);
				var uvr = new UniqueValueRendererDefinition()
				{
					ValueFields = new string[] { "HEIGHT" }
				};
				fl.SetRenderer(fl.CreateRenderer(uvr));
				fl.SetName("Buildings_Hosted_UVR");
				MapView.Active?.ZoomTo(fl.GetFeatureClass().GetExtent());
			});
		}
	}
}
