﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FeatureServiceDemo.Demo2
{
	/// <summary>
	/// Interaction logic for InfoMessageBox.xaml
	/// </summary>
	public partial class InfoMessageBox : Window, INotifyPropertyChanged
	{
		public InfoMessageBox()
		{
			InitializeComponent();
			this.DataContext = this;
		}

		private string message;
		public string Message
		{
			get { return message; }
			set { message = value; RaisePropertyChanged("Message"); }
		}

		public static void Show(string message, string title = "")
		{
			var mbox = new InfoMessageBox();
			mbox.Title = title;
			mbox.Message = message;
			mbox.ShowDialog();
		}

		public event PropertyChangedEventHandler PropertyChanged = delegate { };

		private void RaisePropertyChanged(string property)
		{
			if (PropertyChanged != null)
				PropertyChanged(this, new PropertyChangedEventArgs(property));
		}
	}
}