﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Mapping;

namespace FeatureServiceDemo.Demo3
{
	internal class SelectForBranchDefault : Button
	{
		protected override void OnClick()
		{
			var feature_layers = MapView.Active.Map.GetLayersAsFlattenedList().OfType<FeatureLayer>();

			QueuedTask.Run(() =>
			{
				Module1.Current.ClearSelection();

				var buildings_branch_default = feature_layers.First(fl => fl.Name == "Buildings_Branch (Vers)");

				var oids1 = new List<long> { 47, 46, 245, 143 };
				var qf = new QueryFilter()
				{
					ObjectIDs = oids1
				};
				buildings_branch_default.Select(qf, SelectionCombinationMethod.New);

				Module1.Current.UpdateSelection();
			});
		}
	}
}
